<?php

// WikiKubbe
// Copyleft (C) BohwaZ 2003-2006, licence GNU/GPL (disponible sur www.gnu.org)
// http://kd2.org/ - bohwaz chez kd2 point org

// Wiki source code

require_once("wiki.class.php");
$wiki = new Wiki();

if(!file_exists("config.inc.php"))
{
    $dirHandle = opendir(".");
    while($file = readdir($dirHandle))
    {
        if(!is_dir($file)) continue;
        if(substr($file,-6) == ".pages") {
            header("location: upgrade.php?dir=".$file);
            exit;
        }
    }
    closedir($dirHandle);

    if(!$wiki->IsWritable()) {
        $text = "<p class=\"error\">Le script n'a pas le droit d'crire sur son rpertoire, sur le rpertoire _data ou sur un sous-rpertoire de _data.</p>";
        $text.= "<p>Merci de vrifier les permissions sur ces rpertoires.</p>";
    }
    else
    {
        if($wiki->WriteConfig($wiki->defaultConfig) && $wiki->InitPaths())
        {
            $text = "<p>L'installation de WikiKubbe s'est bien droule.</p>
            <p>Votre mot de passe administrateur est &laquo;&nbsp;<strong>".$wiki->defaultConfig['password']."</strong>&nbsp;&raquo;.</p>
            <p>Rechargez cette page pour accder  votre wiki.</p>";
        }
        else
        {
            $text = "<p class=\"error\">Impossible d'installer WikiKubbe.</p><p>Vrifiez que le script  le droit d'crire dans le rpertoire courant.</p>";
        }
    }

    $wiki->config = $wiki->defaultConfig;

    $wiki->Template('Installation',$text);
    exit;
}

require_once('config.inc.php');

$wiki->config = $config;

// Migration 0.6.0 -> 0.6.1
if($wiki->version == "0.6.1" && $version == "0.6.0")
{
    function PathToLower($path)
    {
        $dir = opendir($path);
        while($file = readdir($dir))
        {
            if(ereg('[A-Z]', $file))
            {
                rename($path.'/'.$file, $path.'/'.strtolower($file));
            }
        }
    }

    PathToLower("_data/pages");
    PathToLower("_data/locks");
    PathToLower("_data/cache");
    $wiki->WriteConfig($config);

    die("La version de WikiKubbe a t mise  jour de la version 0.6.0  0.6.1. Rechargez cette page pour accder au wiki.");
}

if(isset($_GET['page'])) $page = $_GET['page'];
elseif(!empty($_SERVER['argv'][0])) $page = $_SERVER['argv'][0];
elseif(!empty($_SERVER['REDIRECT_STATUS']) && ($_SERVER['REDIRECT_STATUS'] == "404"))
{
    $base = ereg_replace("/$","",dirname($_SERVER['SCRIPT_NAME']))."/";
    $page = str_replace($base,'',$_SERVER['REDIRECT_URL']);

    // Par dfaut le header est 404 et IE souvent renvoie sa propre page d'erreur...
    // Donc on met dans tous les cas un code 200
    header("HTTP/1.1 200 OK");
}
else $page = $wiki->defaultHome;

# Hardlimit pagename lenght
if(strlen($page) > 64) die("Pagename too long.");

$page = $wiki->getPageName($page);

if($_POST['edit']) $mode = 'edit';
elseif($_POST['save']) $mode = 'save';
elseif(in_array($page,array("_login","_logout","_syntax","_config"))) $mode = "special";
elseif($_POST['delete']) $mode = 'delete';
elseif($_POST['delete_all']) $mode = 'delete_all';
elseif($_POST['rename']) { $mode = 'rename'; $newName = $wiki->getPageName($_POST['rename']); }
else $mode = "view";

$haveAccess = $wiki->CheckAccess();
$wiki->haveAccess = $haveAccess;

if($mode == 'save')
{
    if($wiki->config['type'] == "prive" && !$haveAccess && $wiki->IsLocked($page) == NULL)
        die("Vous n'avez pas le droit d'diter cette page.");
    elseif($wiki->IsLocked($page) === TRUE && !$haveAccess)
        die("Vous n'avez pas le droit d'diter cette page.");

    if($_POST['lock'] == "yes") $lock = "lock";
    elseif($_POST['unlock'] == "yes") $lock = "unlock";
    if($wiki->SavePage($page,$_POST['text'],$lock))
        header("location: ".$wiki->PageURL($page));
    else {
        $mode = "edit";
        $error = "Impossible d'enregistrer la page.";
    }
}

if($mode == "view")
{
    if(($wiki->enableIndexes || $haveAccess) && (substr($page,-7) == "%_index")) {
        $title = 'Catgorie: '.str_replace('%','/',substr($page,0,-7));
        $text = $wiki->getIndex(substr($page,0,-6));
        $mode = "special";
    }
    elseif(($wiki->enableIndexes || $haveAccess) && $page == "_index") {
        $text = $wiki->getIndex();
        $title = "Index des pages";
        $mode = "special";
    }
    else {
        $page = $wiki->CheckPageExists($page);
        if($wiki->config['cache'] == "light") $text = $wiki->GetCache($page);
        else $text = $wiki->GetPage($page);
    }

    if(!isset($title))
    {
      if($page == $wiki->defaultHome) {
        $title = $wiki->config['name'];
      }
      else {
        $title = $wiki->getPageTitle($page);
      }
    }

    $wiki->Template($title,$text);
}
elseif($mode == "edit")
{
    if($wiki->config['type'] == "prive" && !$haveAccess && $wiki->IsLocked($page) == NULL)
        die("Vous n'avez pas le droit d'diter cette page.");
    elseif($wiki->IsLocked($page) === TRUE && !$haveAccess)
        die("Vous n'avez pas le droit d'diter cette page.");

    $text = htmlspecialchars($wiki->GetEditPage($page));
    $wiki->Template("Edition de ".$wiki->getPageTitle($page),$text);
}
elseif($mode == "special")
{
    $page = substr($page,1);
    $title = ucfirst($page);

    if($page == "login") {
        if($_POST['password']) {
            if($wiki->Login($_POST['password']))
                header("location: ".$wiki->PageURL($wiki->defaultHome));
            $text = '<p style="color: red;">Mot de passe invalide.</p>';
        }
        $text.= '<form method="post" action="'.$wiki->PageURL('_login','post').'">
        <fieldset>
          <legend>Mot de passe</legend>
          <p><input type="password" name="password" /></p>
        </fieldset>
        <p><input type="submit" name="login" value="Connexion" /></p></form>';
    }
    elseif($page == "logout") {
        $wiki->Logout();
        header("location: ".$wiki->PageURL($wiki->defaultHome));
    }
    elseif($page == "syntax") {
        include_once("class.wiki2xhtml.php");
        $wiki2xhtml = new wiki2xhtml();
        $title = "Syntaxe";
        $text = '<dl><dt>Faire un lien wiki:</dt><dd><ul><li>[:Nom_de_la_page] donne <a href="'.$wiki->PageURL('Nom_de_la_page').'">Nom_de_la_page</a></li>
            <li>[Ceci est un lien|:Nom_de_la_page] donne <a href="'.$wiki->PageURL('Nom_de_la_page').'">Ceci est un lien</a></li></ul></dd></dl>'.
            $wiki2xhtml->help().'<p>Nota: les retours  la ligne sont forcs sur ce wiki.</p>';
    }
    elseif($page == "config")
    {
        if(!$haveAccess) die("Vous n'avez pas accs  cette page.");
        if($_POST['saveconfig']) {
            $wiki->WriteConfig($_POST);
            header("location: ".$wiki->PageURL($wiki->defaultHome));
        }
        $text = '
        <form method="post" action="'.$wiki->PageURL('_config','post').'">
        <fieldset>
          <legend>Accs administrateur</legend>
          <dl>
            <dt>Restriction d\'accs</dt>
            <dd><select name="access">
              <option value="password" '.($wiki->config['access'] == "password" ? 'selected="selected" ' : '').'>Mot de passe</option>
              <option value="ip" '.($wiki->config['access'] == "ip" ? 'selected="selected" ' : '').'>Adresse IP</option>
              <option value="ip or password" '.($wiki->config['access'] == "ip or password" ? 'selected="selected" ' : '').'>Adresse IP OU mot de passe</option>
              <option value="ip and password" '.($wiki->config['access'] == "ip and password" ? 'selected="selected" ' : '').'>Adresse IP ET mot de passe</option>
            </select></dd>
            <dt>Mot de passe</dt>
            <dd><input type="text" name="password" value="'.$wiki->config['password'].'" /></dd>
            <dt>Adresse IP</dt>
            <dd><input type="text" name="ip" value="'.$wiki->config['ip'].'" /></dd>
          </dl>
        </fieldset>
        <dl>
          <dt>Nom du wiki</dt>
          <dd><input type="text" name="name" value="'.stripslashes($wiki->config['name']).'" /></dd>
          <dt>Type de wiki</dt>
          <dd><dl>
            <dt><input type="radio" name="type" value="prive" id="fprive" '.($wiki->config['type'] == "prive" ? 'checked="checked" ' : '').'/>
              <label for="fprive">Priv</label></dt>
            <dd>Seul l\'administrateur peut diter les pages et en rendre certaines ditables par les visiteurs.</dd>
            <dt><input type="radio" name="type" value="public" id="fpublic" '.($wiki->config['type'] == "public" ? 'checked="checked" ' : '').'/>
              <label for="fpublic">Public</label></dt>
            <dd>Toutes les pages sont ditables et l\'administrateur peut en bloquer certaines.</dd>
          </dl></dd>
          <dt>Cache des pages</dt>
          <dd><dl>
            <dt><input type="radio" name="cache" value="none" id="fcachenone" '.($wiki->config['cache'] == "" ? 'checked="checked" ' : '').'/>
              <label for="fcachenone">Aucun</label></dt>
            <dd>Recommand pour un wiki personnel peu ou pas visit.</dd>
            <dt><input type="radio" name="cache" value="light" id="fcachelight" '.($wiki->config['cache'] == "light" ? 'checked="checked" ' : '').'/>
              <label for="fcachelight">Cache Light</label></dt>
            <dd>Recommand pour tout wiki ayant des visiteurs: acclre l\'affichage des pages.</dd>
          </dl></dd>
          <dt>Adresse des pages:</dt>
          <dd><dl>
            <dt><input type="radio" name="urls" id="furl404" value="404" '.($wiki->config['urls'] == "404" ? 'checked="checked" ' : '').'/>
              <label for="furl404">'.($u = 'http://'.$_SERVER['HTTP_HOST'].ereg_replace('/$','',dirname($_SERVER['SCRIPT_NAME']))).'/MaPage</label></dt>
            <dd>Adresses jolies et pratiques mais ne fonctionne pas partout.</dd>
            <dt><input type="radio" name="urls" id="furlpath" value="pathinfo" '.($wiki->config['urls'] == "pathinfo" ? 'checked="checked" ' : '').'/>
              <label for="furlpath">'.$u.'/?MaPage</label></dt>
            <dd>Fonctionne  peu prs partout.</dd>
            <dt><input type="radio" name="urls" id="furlget" value="get" '.($wiki->config['urls'] == "get" ? 'checked="checked" ' : '').'/>
              <label for="furlget">'.$u.'/index.php?page=MaPage</label></dt>
            <dd>Essayez cette mthode si les autres ne fonctionnent pas sur votre hbergeur.</dd>
            </dl>
          </dd>
          <dt><label for="ftheme">Thme</label></dt>
          <dd><select name="theme" id="ftheme">';

        foreach($wiki->GetThemesList() as $theme) {
            $text.= '<option value="'.$theme.'" '.(($theme == $config['theme']) ? ' selected="selected"' : '').'>'.ucfirst($theme).'</option>';
         }

         $text.= '</select></dd>
        </dl>
        <p><input type="submit" name="saveconfig" value="Enregistrer" /></p>
        </form>';
    }

    $wiki->Template($title,$text);
}
elseif($mode == "delete")
{
    if(!$haveAccess) die("Vous n'avez pas le droit de supprimer cette page.");
    $wiki->DeletePage($page);
    header("location: ".$wiki->PageURL('_index'));
}
elseif($mode == "delete_all")
{
    if(!$haveAccess) die("Vous n'avez pas le droit de supprimer cette page.");
    foreach($_POST['check'] as $page) $wiki->DeletePage($page);
    header("location: ".$wiki->PageURL('_index'));
}
elseif($mode == "rename")
{
    if(!$haveAccess) die("Vous n'avez pas le droit de renommer cette page.");
    if(!$wiki->Rename($page,$newName)) die("Cette page existe dj, choisissez un autre nom.");
    header("location: ".$wiki->PageURL($newName));
}
?>
