<?php

// WikiKubbe
// Copyleft (C) BohwaZ 2003-2006, licence GNU/GPL (disponible sur www.gnu.org)
// http://kd2.org/ - bohwaz chez kd2 point org

// Upgrade script from version 0.5.x

function LockPage($page)
{
    $fp = fopen("_data/locks/$page.lock","w");
    fclose($fp);
}

function UnlockPage($page)
{
    $fp = fopen("_data/locks/$page.unlock","w");
    fclose($fp);
}

function UpgradePage($dir,$file)
{
    $texte = implode("",file("$dir/$file"));
    $texte = stripslashes($texte);

    $texte = str_replace("\r","",$texte);
    $i=1; $pos = strpos($texte,"[code]");
    while(is_numeric($pos)) {
        $code[$i] = substr($texte,$pos+6,strpos($texte,"[/code]") - ($pos+6));
        $texte = str_replace("[code]".$code[$i]."[/code]","<CODE({$i})>",$texte);
        $pos = strpos($texte,"[code]");
        $i++;
    }

    $texte = eregi_replace('\[url="([^"]+)"\]([^[]+)\[/url\]','[\\2|\\1]',$texte);

    while(ereg("(^|[ \t\r\n])((([A-Z]+[a-z]+){2,})+([A-Z0-9]+)?)",$texte,$el))
        $texte = str_replace($el[0],$el[1].'[:'.$el[2].']',$texte);
    $texte = eregi_replace("(^|[ \t\r\n])\[([^\n]+\.(png|jpe?g|gif))\]",'\\1((\\2))',$texte);
    while(eregi("(^|[ \t\r\n])\[([a-z0-9_ \.-]+)\]",$texte,$el))
        $texte = str_replace($el[0],$el[1].'[:'.$el[2].']',$texte);

    $texte = eregi_replace("\[img\|right\]([^[]+)\[/img\]","((\\1||R))",$texte);
    $texte = eregi_replace("\[img\|left\]([^[]+)\[/img\]","((\\1||L))",$texte);
    while(eregi("\[quote\]([^[]+)[/quote]",$texte,$el))
        $texte = str_replace($el[0],$el[1]."\n> ".str_replace("\n","\n> ",$el[2])."\n",$texte);

    $tags = array(
        '{{{'=>"!!! ","}}}"=>"","{{"=>"__","}}"=>"__","{"=>"''","}"=>"''",
        "[u]"=>"++","[/u]"=>"++","[img]"=>'((',"[/img]"=>'))');

    $texte = strtr($texte,$tags);
    for($i=1;$i <= count($code); $i++)
        $texte = str_replace("<CODE({$i})>","///\n".trim($code[$i])."\n///",$texte);

    #echo "<textarea cols=50 rows=15>$texte</textarea><br />";

    $page = substr($file,0,-4);
    $page = $GLOBALS['wiki']->getPageName($page);
    $fp = @fopen("_data/pages/$page",'w');
    if(!$fp) die("</p><p><b>Impossible d'ouvrir le fichier '_data/pages/$page' en criture.</b></p>");
    fputs($fp,stripslashes($texte));
    fclose($fp);
}

if(file_exists("config.inc.php")) { header("location: ./"); exit; }
$origDir = $_GET['dir'];
if(!file_exists($origDir)) die("Impossible de trouver $origDir");

require_once("wiki.class.php");
$wiki = new Wiki();

echo '<p>WikiKubbe est en train de se mettre  jour  partir du rpertoire <strong>'.$origDir.'</strong>. Veuillez patienter.</p><hr />';

echo '<h3>Cration de la structure de stockage</h3>';
$wiki->InitPaths();
echo '<p>OK</p><hr />';
echo '<h3>Import de la configuration...</h3>';
flush();

if(!file_exists($origDir.'/config.inc.php')) die('<p><b>Erreur: le fichier de configuration n\'existe pas</b></p>');
if(!include($origDir.'/config.inc.php')) die('<p><b>Erreur: impossible de charger le fichier de configuration</b></p>');
if(empty($nom_wiki) || empty($type)) die('<p><b>Erreur: Fichier de configuration invalide</b></p>');
echo '<p>Nom du wiki: '.$nom_wiki.'<br />Type de wiki: '.$type.'<br />Authentification: ';
if(isset($pass) && isset($ip)) { echo 'Mot de passe et adresse IP'; $access = 'ip and password'; }
elseif(isset($pass)) { echo 'Mot de passe'; $access = 'password'; }
elseif(isset($ip)) { echo 'adresse IP'; $access = 'ip'; }
else { $pass = 'abcd'; echo 'Aucune (?!) - Voir plus bas'; $none = TRUE; $access = 'password'; }
echo '</p>';

$config = $wiki->defaultConfig;
$config['password'] = $pass;
$config['ip'] = $ip;
$config['access'] = $access;
$config['name'] = $nom_wiki;
$config['type'] = $type;

if(!$wiki->WriteConfig($config)) die('<p><b>Erreur: Impossible d\'ouvrir le nouveau fichier de configuration en criture.</b></p>');

echo '<p><i>OK.</i>';
if($none) echo " - Attention votre wiki n'avait pas d'authentification, nous lui avons donc donn une authentification par mot de passe. <b>Ce mot de passe est 'abcd'.</b>";
echo '</p>';
echo '<hr /><h3>Import et conversion des pages existantes</h3><p id="current"></p>
<script type="text/javascript"> function UpdateStatus(Current) { document.getElementById("current").innerHTML = Current; } </script>';
flush();

$dir = opendir($origDir);
$i=1;
while($file = readdir($dir))
{
    if(substr($file,-4) == ".kub") {
        echo "<script type=\"text/javascript\">UpdateStatus('".substr($file,0,-4)."...');</script>";
        flush();
        UpgradePage($origDir,$file);
        #echo 'OK.<br />';
        $i++;
    }
    elseif(substr($file,-5) == ".lock") LockPage(substr($file,0,-5));
    elseif(substr($file,-7) == ".unlock") UnlockPage(substr($file,0,-7));
}
closedir($dir);

echo '<script type="text/javascript">UpdateStatus("'.$i.' pages importes.");</script><p><i>OK.</i></p><hr />';
echo '<p>Votre installation de wikikubbe a t mise  jour. Votre ancien rpertoire '.$origDir.' n\'a pas t supprim, vous pouvez le supprimer vous-mme si vous estimez que tout s\'est bien
droul.</p><p><a href="./">Cliquez ici pour aller  l\'accueil de votre wikikubbe</a></p>';

?>
