<?php

// WikiKubbe
// Copyleft (C) BohwaZ 2003-2006, licence GNU/GPL (disponible sur www.gnu.org)
// http://kd2.org/ - bohwaz chez kd2 point org

// Wiki class

class Wiki
{
    // You can modify these settings if you want
    var $defaultHome = "home";  # default page as home
    var $enableIndexes = true; # Enable indexes for visitors?
    var $cookieName = "wikiKubSession";

    // Don't touch these
    var $defaultConfig = array('password'=>'abcd','access'=>'password','ip'=>'','name'=>'Mon wiki','type'=>'public','cache'=>'light',
        'urls'=>'get','theme'=>'default');
    var $config;
    var $haveAccess = false;
    var $version = "0.6.1";
    var $createDirs = array("_data","_data/pages","_data/cache","_data/locks","_data/media");

    function CheckAccess()
    {
        $mode = $this->config['access'];
        if($mode == "free") return TRUE;
        $mode = explode(" ",$mode);

        @ini_set('session.use_only_cookies',1);

        if(in_array("ip",$mode)) $ip = $_SERVER['REMOTE_ADDR'];
        if(in_array("or",$mode)) $or = TRUE;
        if(in_array("password",$mode)) { @session_start(); $password = $_SESSION[$this->cookieName]; $passEnabled = TRUE; }
        if(!$ip && !$passEnabled) return TRUE;
        $truePassword = md5($this->config['password']);
        $trueIP = $this->config['ip'];

        if(($ip && $or && $passEnabled) && (($ip == $trueIP) || ($password == $truePassword))) return TRUE;
        elseif(($ip && $passEnabled) && (($ip == $trueIP) && ($password == $truePassword))) return TRUE;
        elseif($ip && $ip == $trueIP) return TRUE;
        elseif($passEnabled && $password == $truePassword) return TRUE;
        return FALSE;
    }

    function Login($password)
    {
        $truePassword = $this->config['password'];
        if($password != $truePassword) return FALSE;

        @session_set_cookie_params(0,'/');
        @session_start();
        $_SESSION[$this->cookieName] = md5($password);
        return TRUE;
    }

    function Logout()
    {
        @session_start();
        $_SESSION = array();
        @session_unset();
        @session_destroy();
        return TRUE;
    }

    function IsWritable()
    {
        if(!is_writable('.')) return false;
        foreach($this->createDirs as $dir) {
            if(!file_exists($dir)) continue;
            if(!is_writable($dir)) return false;
            if(!is_dir($dir)) return false;
        }
        return true;
    }

    function WriteConfig($config)
    {
        $file[] = '<?php # Wikikubbe configuration, please use wikikubbe to edit it';
        $file[] = '$config["name"] = "'.$config['name'].'";';
        $file[] = '$config["type"] = "'.$config['type'].'";';
        $file[] = '$config["access"] = "'.$config['access'].'";';
        $file[] = '$config["password"] = "'.$config['password'].'";';
        $file[] = '$config["ip"] = "'.$config['ip'].'";';
        $file[] = '$config["cache"] = "'.$config['cache'].'";';
        $file[] = '$config["urls"] = "'.$config['urls'].'";';
        $file[] = '$config["theme"] = "'.$config['theme'].'";';
        $file[] = '$version = "'.$this->version.'";';
        $file[] = '?>';
        $file = implode("\n",$file);

        $fp = @fopen("config.inc.php","w");
        if(!$fp) return false;
        fputs($fp,$file);
        fclose($fp);
        return true;
    }

    function InitPaths()
    {
        foreach($this->createDirs as $dir)
        {
            if(file_exists($dir) && is_dir($dir)) continue;
            if(!@mkdir($dir)) return false;
        }

        $this->WriteHtaccess("_data/pages",'lock');
        $this->WriteHtaccess("_data/cache",'lock');
        $this->WriteHtaccess(".",'redir');
        return true;
    }

    function WriteHtaccess($path,$type)
    {
        $fp = @fopen("$path/.htaccess","w");
        if(!$fp) return false;

        if($type == "lock") {
            $content = "Order deny,allow\nAllow from none\nDeny from all\n";
        }
        elseif($type == "redir")
        {
            $base = ereg_replace("/$","",dirname($_SERVER['SCRIPT_NAME']));
            $content = "# For 404 error redirect:\n\nErrorDocument 404 {$base}/index.php\n\n".
                "# For Rewrite Rule redirect:\n\n# RewriteEngine On\n# RewriteCond...";
        }

        fputs($fp,$content);
        fclose($fp);
        return true;
    }

    function getPageName($page)
    {
        $page = urldecode($page);
        $page = strtr($page," /:","aaaeeeecuuuooAAEEEECUUUOO_%%");
        $page = eregi_replace("[^a-z0-9_%]","",$page);
        $page = strtolower($page);
        return $page;
    }

    function getPageTitle($page,$showPath=false)
    {
        $page = str_replace("_"," ",$page);
        if(strpos($page,"%")) {
            if($showPath) $page = str_replace('%','/',$page);
            else { $page = explode('%',$page); $page = $page[count($page)-1]; }
        }
        $page = ucfirst($page);
        return $page;
    }

    function getCategoryIndex($page)
    {
        $cat = explode("%",$page);
        unset($cat[count($cat)-1]);
        $cat = implode("%",$page);

        $dir = opendir("_data/pages/");
        while($file = readdir($dir))
        {
            if(strpos($dir,$cat)) echo strpos($dir,$cat)."<br>";
        }
    }

    function getIndex($prefix="",$count=true)
    {
        $dir = opendir("_data/pages/");
        while($file = readdir($dir))
        {
            if(!empty($prefix)) if(!ereg("^$prefix",$file)) continue;
            if(substr($file,0,1) == ".") continue;
            if(!empty($prefix)) $file = str_replace($prefix,'',$file);
            $files[] = $file;
        }
        if(count($files) < 1) return '<p>Aucune page dans cette catgorie.</p>';

        natcasesort($files);
        if($this->haveAccess && empty($prefix)) $admin = true;

        foreach($files as $file)
        {
            if(($letter = strtoupper(substr($file,0,1))) != $opened) {
                if($opened) $out.= "</ul>\n";
                $out.= '<h3><a name="'.$letter.'">'.$letter."</a></h3>\n<ul>";
                $opened = $letter;
                $letters[] = $letter;
            }
            $out.= '  <li>'.($admin ? '<input type="checkbox" name="check[]" value="'.$file.'" /> ' : '').
                '<a href="'.$this->PageURL($prefix.$file).'">'.$this->getPageTitle($file,true)."</a></li>\n";
        }

        $out.= '</ul>';
        foreach($letters as $letter)
            $let[]= '<a href="#'.$letter.'">'.$letter.'</a>';

        $out2 = '<div class="index">';
        if($count) $out2.= '<p>'.count($files).' pages trouves.</p>';
        $out2.= '<p>'.implode(' - ',$let).'</p><hr />';

        if($admin) {
            $out2.= '<form method="post" action="'.$this->PageURL('_index', 'post').'" onsubmit="return ConfirmDelete();">
            <script type="text/javascript">
            function ConfirmDelete() {
                Confirm = confirm("Etes-vous sr de vouloir supprimer les pages coches ?");
                if(Confirm == false) {
                    return false;
                }
                return true;
            }
            </script>
            <input type="submit" name="delete_all" value="Supprimer les pages coches" />'.$out.'</form>';
        }
        else $out2.= $out;

        $out2.= '</div>';

        return $out2;
    }

    function CheckPageExists($page)
    {
        $page = $this->getPageName($page);
        if(file_exists("_data/pages/".$page)) return $page;
        if(file_exists("_data/pages/".$page."s")) return $page."s";
        if(ereg('s$',$page))  {
            if(file_exists("_data/pages/".substr($page,0,-1))) return substr($page,0,-1);
        }
        return $page;
    }

    function GetPage($page)
    {
        $file = @file("_data/pages/".$page);
        if(!$file) return "Cette page n'existe pas. Cliquez sur diter pour la crer.";

        $file = implode("", $file);
        include_once("class.wiki2xhtml.php");
        $wiki2xhtml = new wiki2xhtml();
        $text = $wiki2xhtml->Transform($file);

        return $text;
    }

    function GetCache($page)
    {
        $file = @file("_data/cache/$page.light");
        if(!$file) return $this->GetPage($page);

        $file = implode("",$file);
        return $file;
    }

    function GetEditPage($page)
    {
        $file = @file("_data/pages/$page");
        if(!$file) return "Cette page n'existe pas. Dcrivez-la ici et cliquez sur enregistrer pour la crer.";

        $file = implode("",$file);
        $file = str_replace('\\','\\\\',$file);

        return $file;
    }

    function SavePage($page,$text,$lock="")
    {
        // Hard limit to 64K text against spam and other attacks
        if(strlen($text) > 65535) $text = substr($text,0,65535);

        $fp = fopen("_data/pages/$page","w");
        if(!$fp) return false;
        fputs($fp,stripslashes($text));
        fclose($fp);

        if($lock == "lock") {
            $fp = @fopen("_data/locks/$page.lock","w");
            @fclose($fp);
        }
        elseif($lock == "unlock") {
            $fp = @fopen("_data/locks/$page.unlock","w");
            @fclose($fp);
        }
        else {
            $locked = $this->IsLocked($page);
            if($locked == TRUE) $this->DeleteFile("_data/locks/$page.lock");
            if($locked === FALSE) $this->DeleteFile("_data/locks/$page.unlock");
        }

        if($this->config['cache'] == "light") {
            $cache = $this->GetPage($page);
            $fp = @fopen("_data/cache/$page.light","w");
            @fputs($fp,$cache);
            @fclose($fp);
        }

        return true;
    }

    function DeleteFile($file)
    {
        if(!@unlink($file)) return false;
        return true;
    }

    function DeletePage($page)
    {
        $this->DeleteFile("_data/pages/".$page);
        $this->DeleteFile("_data/locks/$page.lock");
        $this->DeleteFile("_data/locks/$page.unlock");
        $this->DeleteFile("_data/cache/$page.light");
        return true;
    }

    function getDate($page)
    {
        return @filemtime("_data/pages/$page");
    }

    function IsLocked($page)
    {
        if(file_exists("_data/locks/$page.lock")) return TRUE;
        if(file_exists("_data/locks/$page.unlock")) return FALSE;
        return NULL;
    }

    function PageURL($page,$method='')
    {
        $page = str_replace('%','/',$page);

        switch($this->config['urls'])
        {
            case "404":
                if($method == "post") $url = "index.php?page=".$page;
                else $url = ereg_replace('/$','',dirname($_SERVER['SCRIPT_NAME'])).'/'.$page;
                break;
            case "rewrite":
                $url = ereg_replace('/$','',dirname($_SERVER['SCRIPT_NAME'])).'/'.$page;
                break;
            case "pathinfo":
                $url = "./?".$page;
                break;
            case "get":
                $url = "./index.php?page=".$page;
                break;
        }

        return $url;
    }

    function GetThemesList()
    {
        $dir = opendir("themes");
        $themes = array();
        while($file = readdir($dir)) {
            if(substr($file,0,1) == '.') continue;
            if(is_dir('themes/'.$file) && file_exists('themes/'.$file.'/template.php')) {
                $themes[] = $file;
            }
        }
        closedir($dir);
        return $themes;
    }

    function Template($title,$text,$sidebar="")
    {
        $title = htmlspecialchars(stripslashes($title));
        $text = stripslashes($text);
        $sidebar = stripslashes($sidebar);
        $page = $GLOBALS['page'];
        $mode = $GLOBALS['mode'];
        $haveAccess = $this->haveAccess;
        $locked = $this->IsLocked($page);
        $realName = str_replace('%','/',$page);
        $this->config['name'] = stripslashes($this->config['name']);

        include_once("themes/".$this->config['theme']."/template.php");
    }

    function Rename($old,$new)
    {
        if(file_exists("_data/pages/$new")) return false;
        rename("_data/pages/$old","_data/pages/$new");
        @rename("_data/cache/$old.light","_data/cache/$new.light");
        @rename("_data/locks/$old.lock","_data/locks/$new.lock");
        @rename("_data/locks/$old.unlock","_data/locks/$new.unlock");
        return true;
    }
}

?>
